// Copyright 2018 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license
// that can be found in the LICENSE file.

// Flags: --allow-natives-syntax

(()=> {
  function f(a) {
    return a.charAt(1) == "";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) < "";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) <= "";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) > "";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aaa"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aaa"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) >= "";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aaa"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aaa"));
})();


(()=> {
  function f(a) {
    return a.charAt(1) == a.charAt(2);
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aab"));
  assertEquals(true, f("aaa"));
  assertEquals(false, f("acb"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aab"));
  assertEquals(true, f("aaa"));
  assertEquals(false, f("acb"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) < a.charAt(2);
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aab"));
  assertEquals(false, f("aaa"));
  assertEquals(false, f("acb"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aab"));
  assertEquals(false, f("aaa"));
  assertEquals(false, f("acb"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) <= a.charAt(2);
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aab"));
  assertEquals(true, f("aaa"));
  assertEquals(false, f("acb"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aab"));
  assertEquals(true, f("aaa"));
  assertEquals(false, f("acb"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) > a.charAt(2);
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aab"));
  assertEquals(false, f("aaa"));
  assertEquals(true, f("acb"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aab"));
  assertEquals(false, f("aaa"));
  assertEquals(true, f("acb"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) >= a.charAt(2);
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aab"));
  assertEquals(true, f("aaa"));
  assertEquals(true, f("acb"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aab"));
  assertEquals(true, f("aaa"));
  assertEquals(true, f("acb"));
})();


(()=> {
  function f(a) {
    return a.charAt(1) == "b";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) == "bb";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
})();


(()=> {
  function f(a) {
    return a.charAt(1) < "b";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(false, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(false, f("ccc"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) < "bb";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
})();


(()=> {
  function f(a) {
    return a.charAt(1) <= "b";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) <= "bb";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(true, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(true, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(false, f("ccc"));
})();


(()=> {
  function f(a) {
    return a.charAt(1) > "b";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(true, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(true, f("ccc"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) > "bb";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(true, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(true, f("ccc"));
})();


(()=> {
  function f(a) {
    return a.charAt(1) >= "b";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(true, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
  assertEquals(true, f("bbb"));
  assertEquals(true, f("ccc"));
})();

(()=> {
  function f(a) {
    return a.charAt(1) >= "bb";
  }
  v8PrepareFunctionForOptimization(f);
  assertEquals(false, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(true, f("ccc"));
  v8OptimizeFunctionOnNextCall(f);
  assertEquals(false, f("aaa"));
  assertEquals(false, f("bbb"));
  assertEquals(true, f("ccc"));
})();
