// Copyright 2021 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

let o1 = { a: 1, b: 0 };
let o2 = { a: 2, b: 0 };
assertTrue(v8HaveSameMap(o1, o2));
assertTrue(v8HasOwnConstDataProperty(o1, "a"));
assertTrue(v8HasOwnConstDataProperty(o1, "b"));

Object.defineProperty(o1, "b", {
  value: 4.2, enumerable: true, configurable: true, writable: true,
});
assertFalse(v8HaveSameMap(o1, o2));
assertTrue(v8HasOwnConstDataProperty(o1, "a"));
assertFalse(v8HasOwnConstDataProperty(o1, "b"));
assertTrue(v8HasOwnConstDataProperty(o2, "a"));
assertTrue(v8HasOwnConstDataProperty(o2, "b"));

let o3 = { a: "foo", b: 0 };
assertFalse(v8HaveSameMap(o2, o3));
assertTrue(v8HasOwnConstDataProperty(o3, "a"));
assertFalse(v8HasOwnConstDataProperty(o3, "b"));

Object.defineProperty(o2, "a", {
  value:2, enumerable: false, configurable: true, writable: true,
});
assertTrue(v8HasOwnConstDataProperty(o1, "a"));
assertFalse(v8HasOwnConstDataProperty(o1, "b"));
assertTrue(v8HasOwnConstDataProperty(o3, "a"));
assertFalse(v8HasOwnConstDataProperty(o3, "b"));

assertFalse(v8HasOwnConstDataProperty(o2, "a"));
assertTrue(v8HasOwnConstDataProperty(o2, "b"));
